std::is_trivial(3)

NAME
std::is_trivial - std::is_trivial

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_trivial;
   If T is a trivial type, provides the member constant value equal to true. For any
   other type, value is false.
   The behavior is undefined if std::remove_all_extents_t<T> is an incomplete type and
   not (possibly cv-qualified) void.
   The behavior of a program that adds specializations for is_trivial
   or is_trivial_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_trivial_v = is_trivial<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a trivial type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template<class T>
   struct is_trivial : std::integral_constant<
       bool,
       std::is_trivially_copyable<T>::value &&
       std::is_trivially_default_constructible<T>::value
   > {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 struct A
 {
     int m;
 };
 struct B
 {
     B() {}
 };
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_trivial<A>::value << '\n';
     std::cout << std::is_trivial<B>::value << '\n';
 }

Output:
 true
 false

See also
   is_trivially_copyable checks if a type is trivially copyable
   (C++11) (class template)
   is_default_constructible
   is_trivially_default_constructible
   is_nothrow_default_constructible checks if a type has a default constructor
   (C++11) (class template)
   (C++11)
   (C++11)